from picamera import PiCamera
from threading import Thread
import time
import sys

def main(args):
    video_length = args[0]
    sample_rate = float(args[1])
    steps = int(float(video_length) / float(sample_rate))

    def configure_camera():
        returnCam = PiCamera()

        returnCam.shutter_speed = 500
        returnCam.resolution = (512,512)
        returnCam.color_effects = (128,128)

        return returnCam

    camera = configure_camera()

    filename = '/mnt/share/temp/{counter}.png'
    start = time.time()
    for i, filename in enumerate(camera.capture_continuous(filename, format='png')):
        now = time.time()
        time.sleep(sample_rate - (now - start))
        if i == (steps - 1):
            break
        start = time.time()

try:
	main(sys.argv[1:])
except IndexError:
	print("You must run this application from the command line")
