import socket
import time
import picamera
import os
import sys
import shutil
from time import strftime as get_time

camera = picamera.PiCamera()
camera.resolution = (512, 512)
camera.color_effects = (128,128)
camera.framerate = 20
try:
    server_socket = socket.socket()
    server_socket.bind(('0.0.0.0', 8000))
    server_socket.listen(0)
    connection = server_socket.accept()[0].makefile('wb')

    camera.start_recording(connection, format='h264')
    continue_streaming = True
    recording_video = False
    seconds_counter = 0
    while continue_streaming:
        camera.wait_recording(1)
        if os.path.exists("/mnt/share/handshaking/stopstreaming.txt"):
            #os.remove("/mnt/share/handshaking/stopstreaming.txt")
            continue_streaming = False
            camera.stop_recording()
        if os.listdir("/mnt/share/handshaking/captureimage") != []:
            camera.capture('/mnt/share/temp/temp.png', use_video_port=True)
            shutil.rmtree("/mnt/share/handshaking/captureimage")
            os.makedirs("/mnt/share/handshaking/captureimage")
        if os.listdir("/mnt/share/handshaking/capturebackground") != []:
            sample_rate = 1
            steps = 30
            filename = '/mnt/share/temp/{counter}.png'
            start = time.time()
            for i, filename in enumerate(camera.capture_continuous(filename, use_video_port=True, format='png')):
                now = time.time()
                time.sleep(sample_rate - (now - start))
                if i == (steps - 1):
                    break
                start = time.time()
            shutil.rmtree("/mnt/share/handshaking/capturebackground")
            os.makedirs("/mnt/share/handshaking/capturebackground")
finally:
    server_socket.close()
    
